//
// Utilisation de new et delete : prog20.cc
//				  cas des tableaux de dimension 2
//

#include <stdio.h>
#include <stdlib.h>


void lecture(int **, int);
void affiche(int **, int);
void alloue(int **&, int);
void libere(int **);


int main()
{
 int taille, resultat;
 int **matrice;

 printf("Taille de la matrice : ");
 while((resultat = scanf("%d", &taille)) != EOF)
 {
  if (resultat != 1 || taille < 0)
    fprintf(stderr, "Erreur : valeur incorrecte\n");
    else
    {
     alloue(matrice, taille);
     lecture(matrice, taille);
     affiche(matrice, taille);
     libere(matrice);
    }
  fflush(stdin);
  printf("Combien de lignes : ");
 }
 return 0;
}

// Allocation dynamique d'un tableau de dimension 2
void alloue(int **&mat, int taille)
{
 int i, j;
 int *matlin = new int[taille * taille];
 mat   = new int *[taille];
 for(i = 0; i < taille; i++) mat[i] = matlin + i * taille;
}

// Lecture du tableau
void lecture(int **ptr, int taille)
{
 int i, j;
 for(i = 0; i < taille; i++)
   for(j = 0; j < taille; j++)
   {
    printf("tab[%d][%d] = ", i, j);
    scanf("%d",&ptr[i][j]);
   }
}

// Affichage du tableau
void affiche(int **ptr, int taille)
{
 int i, j;
 printf("La matrice : \n");
 for(i = 0; i < taille; i++)
 {
   for(j = 0; j < taille; j++)
    printf("tab[%d][%d] = %d\n", i, j,ptr[i][j]);
 }
}

void libere(int **matrice)
{
 delete [] matrice[0];
 delete [] matrice;
}

