#include <string>
#include <iostream>
#include <memory> // std::auto_ptr
using namespace std;

class Animal {
public:
    virtual void cri() const = 0;
    virtual ~Animal() {};
};
 
class Chien: public Animal {
public:
    virtual void cri() const {
        cout << "Ouf Ouf" << endl;
    }
};
 
class Chat : public Animal {
public:
    virtual void cri() const {
        cout << "Miaou Miaou" << endl;
    }
};
 
class Bestiole : public Animal {
public:
    virtual void cri() const {
        cout << "Zzz bbvq" << endl;
    }
};
 
class MenagerieFabrique {
public:
    static Animal* naissance(const string& type) {
        if (type == "Chien")
            return new Chien();
        else if (type == "Chat")
            return new Chat();
        else
            return new Bestiole();
    }
};

int main() {
    MenagerieFabrique fabrique;
 
    auto_ptr<const Animal> animal(fabrique.naissance("Defaut"));
    animal->cri();
 
    animal.reset(fabrique.naissance("Chien"));
    animal->cri();
 
    animal.reset(fabrique.naissance("Chat"));
    animal->cri();

    return 0;
}
